package org.fluff.splodge.scim;

import java.io.*;
import java.lang.reflect.*;

/**
22nd June 2004, 15:04 -> 15:10

@author Phil Norman
*/

public class MethodCaller implements Runnable {
	private SCIMConnection connection;
	private int requestId;
	private Object reference;
	private String methodName;
	private Class[] types;
	private Object[] args;
	
	public MethodCaller(SCIMConnection connection, int requestId, Object reference, String methodName, Class[] types, Object[] args) {
		this.connection = connection;
		this.requestId = requestId;
		this.reference = reference;
		this.methodName = methodName;
		this.types = types;
		this.args = args;
	}
	
	public void start() {
		(new Thread(this, "Method Caller")).start();
	}
	
	public void run() {
		try {
			try {
				Method method = reference.getClass().getMethod(methodName, types);
				Object result = method.invoke(reference, args);
				connection.sendResult(requestId, result, false);
			} catch (Exception ex) {
				connection.sendResult(requestId, ex, true);
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
