package org.fluff.splodge.scim;

import java.io.*;

/**
A SCIMRemoteObject is the superclass of all objects which may have remote references.
It's effectively the equivalent of the UnicastRemoteObject (or other RemoteObject subclasses)
in RMI.

22nd June 2004, 15:50 -> 15:53

@author Phil Norman
*/

public class SCIMRemoteObject implements Serializable {
	public Object writeReplace() throws ObjectStreamException {
		int id = SCIMConnection.getConnectionForThread().registerAsRemotelyReferenced(this);
		return new SCIMToken(getClass(), id);
	}
}
