package org.fluff.splodge.scim;

import java.io.*;
import java.net.*;

/**
A SCIMServer sets up a server listening for client connections.

Started: 22nd June 2004, 14:11
Finished: 22nd June 2004, 14:16

@author Phil Norman
*/

public class SCIMServer implements Runnable {
	private ServerSocket sock;
	private SCIMRemote serverObj;
	
	public SCIMServer(int port, SCIMRemote serverObj) throws IOException {
		sock = new ServerSocket(port);
		this.serverObj = serverObj;
		start();
	}
	
	public SCIMServer(int port, SCIMRemote serverObj, InetAddress bindAddress) throws IOException {
		sock = new ServerSocket(port, 100, bindAddress);
		this.serverObj = serverObj;
		start();
	}
	
	private void start() {
		(new Thread(this, "SCIM Connection Listener")).start();
	}
	
	public void run() {
		while (true) {
			try {
				Socket socket = sock.accept();
				SCIMConnection connection = new SCIMConnection(socket);
				connection.sendServerReference(serverObj);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}
}
