package org.fluff.splodge.test;

import java.io.*;

import org.fluff.splodge.scim.*;

/**

23rd June 2004, 09:43 -> 09:46

@author Phil Norman
*/

public class DirListerImpl extends SCIMRemoteObject implements DirLister {
	private File path;
	
	public DirListerImpl(File path) {
		this.path = path;
	}
	
	public String[] getDirectoryListing() {
		return path.list();
	}

	public long getSize(String entry) {
		return (new File(path, entry)).length();
	}
	
	public void changeDirectory(String entry) {
		File newPath = new File(path, entry);
		if (newPath.isDirectory()) {
			path = newPath;
		} else {
			throw new IllegalArgumentException("File " + newPath.getPath() + " is not a directory.");
		}
	}
	
	public boolean isDirectory(String entry) {
		return (new File(path, entry)).isDirectory();
	}
	
	public void upDirectory() {
		File parent = path.getParentFile();
		if (parent != null) {
			path = parent;
		}
	}
	
	public String getPath() {
		return path.getPath();
	}
}
