package org.fluff.splodge.test;

import java.io.*;

import org.fluff.splodge.scim.*;

/**
A simple test server which starts up the SCIM server and gets it listening on a
certain port.

23rd June 2004, 09:36 -> 09:40

@author Phil Norman
*/

public class Server extends SCIMRemoteObject implements TestServer {

	public DirLister getDirLister() {
		return new DirListerImpl((new File(".")).getAbsoluteFile());
	}

	public static void main(String[] argv) {
		if (argv.length != 1) {
			System.err.println("Usage: Server <port number>");
			System.exit(1);
		}
		int port = Integer.parseInt(argv[0]);
		try {
			new SCIMServer(port, new Server());
		} catch (IOException ex) {
			System.err.println("Failed to set up server on port " + port + ".");
			ex.printStackTrace();
		}
	}
}
