package org.fluff.splodge.util;

import java.util.*;

/**
A BlockingPipe is an object pipe (a FIFO, essentially) where the get method blocks
until there's something to return.

Started: 22nd June 2004, 11:40
Finished: 22nd June 2004, 11:43

@author Phil Norman
*/

public class BlockingPipe {
	private ArrayList contents = new ArrayList();
	
	public synchronized void add(Object obj) {
		contents.add(obj);
		notify();
	}
	
	public synchronized void addAll(Collection objects) {
		contents.addAll(objects);
		notifyAll();
	}
	
	public synchronized Object get() {
		while (contents.size() == 0) {
			try {
				wait();
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}
		}
		return contents.remove(0);
	}
}
