package org.fluff.splodge.util;

/**
An IdGenerator generates a list of monotonically increasing ID numbers.  It's intended as a simple
thread-safe way of doing so without having to pollute code with a lot of synchronization checking.

22nd June 2004, 15:21 -> 15:22

@author Phil Norman
*/

public class IdGenerator {
	private int nextId = 1;
	
	public synchronized int get() {
		return nextId++;
	}
}
